"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = unifyAsyncCall;
exports.setCacheObject = setCacheObject;

var _md = require("md5");

var _md2 = _interopRequireDefault(_md);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var unifierCache = new Map();
function unifyAsyncCall(func) {
  var resolver = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function () {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return JSON.stringify(args);
  };

  return function () {
    var key = (0, _md2.default)(func.toString() + "_" + resolver.apply(undefined, arguments));

    if (unifierCache.has(key)) {
      return unifierCache.get(key);
    }

    var result = func.apply(undefined, arguments);

    if (!(result instanceof Promise)) {
      throw new TypeError("The decorated method must return promise.");
    }

    result = result.catch(function (error) {
      unifierCache.delete(key);

      throw error;
    }).then(function (response) {
      unifierCache.delete(key);

      return response;
    });

    unifierCache.set(key, result);

    return result;
  };
}

function setCacheObject(cache) {
  unifierCache = cache;
}